<html>
<head>
<title>OGRE: OgreProfiler.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreProfiler.h</h1><a href="OgreProfiler_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="comment">/*</span>
<a name="l00030"></a>00030 <span class="comment"></span>
<a name="l00031"></a>00031 <span class="comment">    Although the code is original, many of the ideas for the profiler were borrowed from </span>
<a name="l00032"></a>00032 <span class="comment">"Real-Time In-Game Profiling" by Steve Rabin which can be found in Game Programming</span>
<a name="l00033"></a>00033 <span class="comment">Gems 1.</span>
<a name="l00034"></a>00034 <span class="comment"></span>
<a name="l00035"></a>00035 <span class="comment">    This code can easily be adapted to your own non-Ogre project. The only code that is </span>
<a name="l00036"></a>00036 <span class="comment">Ogre-dependent is in the visualization/logging routines and the use of the Timer class.</span>
<a name="l00037"></a>00037 <span class="comment"></span>
<a name="l00038"></a>00038 <span class="comment">    Enjoy!</span>
<a name="l00039"></a>00039 <span class="comment"></span>
<a name="l00040"></a>00040 <span class="comment">*/</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="preprocessor">#ifndef __Profiler_H__</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">#define __Profiler_H__</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include "<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>"</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include "<a class="code" href="OgreString_8h.html">OgreString.h</a>"</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include "<a class="code" href="OgreOverlay_8h.html">OgreOverlay.h</a>"</span>
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="preprocessor">#if OGRE_PROFILING == 1</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#   if OGRE_COMPILER != OGRE_COMPILER_BORL</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#       define OgreProfile( a ) Ogre::Profile _OgreProfileInstance( (a) )</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#       define OgreProfileBegin( a ) Ogre::Profiler::getSingleton().beginProfile( (a) )</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#       define OgreProfileEnd( a ) Ogre::Profiler::getSingleton().endProfile( (a) )</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#   else</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#       define OgreProfile( a ) Ogre::Profile _OgreProfileInstance( __FUNC__ )</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span><span class="preprocessor">#       define OgreProfileBegin( a ) Ogre::Profiler::getSingleton().beginProfile( __FUNC__ )</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span><span class="preprocessor">#       define OgreProfileEnd( a ) Ogre::Profiler::getSingleton().endProfile( __FUNC__ )</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span><span class="preprocessor">#   endif</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00061"></a><a class="code" href="OgreProfiler_8h.html#1654899e6cfdec9f0972a45f3fa3fee7">00061</a> <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfile( a )</span>
<a name="l00062"></a><a class="code" href="OgreProfiler_8h.html#f9d7ab83c5a5d7de7579eebe9d27e53d">00062</a> <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileBegin( a )</span>
<a name="l00063"></a><a class="code" href="OgreProfiler_8h.html#292ec22b5d851ef26fa9d7685c18b1f5">00063</a> <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileEnd( a )</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>
<a name="l00066"></a>00066 <span class="keyword">namespace </span>Ogre {
<a name="l00067"></a>00067 
<a name="l00078"></a><a class="code" href="classOgre_1_1Profile.html">00078</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Profile.html" title="An individual profile that will be processed by the Profiler.">Profile</a> {
<a name="l00079"></a>00079 
<a name="l00080"></a>00080         <span class="keyword">public</span>:
<a name="l00081"></a>00081             <a class="code" href="classOgre_1_1Profile.html" title="An individual profile that will be processed by the Profiler.">Profile</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName);
<a name="l00082"></a>00082             ~<a class="code" href="classOgre_1_1Profile.html" title="An individual profile that will be processed by the Profiler.">Profile</a>();
<a name="l00083"></a>00083 
<a name="l00084"></a>00084         <span class="keyword">protected</span>:
<a name="l00085"></a>00085 
<a name="l00087"></a><a class="code" href="classOgre_1_1Profile.html#24b779884f27e23f87bb0e9f256d6ac1">00087</a>             <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mName;
<a name="l00088"></a>00088             
<a name="l00089"></a>00089 
<a name="l00090"></a>00090     };
<a name="l00091"></a>00091 
<a name="l00103"></a><a class="code" href="classOgre_1_1Profiler.html">00103</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;Profiler&gt; {
<a name="l00104"></a>00104 
<a name="l00105"></a>00105         <span class="keyword">public</span>:
<a name="l00106"></a>00106             <a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a>();
<a name="l00107"></a>00107             ~<a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a>();
<a name="l00108"></a>00108 
<a name="l00110"></a>00110             <span class="keywordtype">void</span> setTimer(<a class="code" href="classOgre_1_1Timer.html" title="Timer class.">Timer</a>* t);
<a name="l00111"></a>00111 
<a name="l00113"></a>00113             <a class="code" href="classOgre_1_1Timer.html" title="Timer class.">Timer</a>* getTimer();
<a name="l00114"></a>00114 
<a name="l00127"></a>00127             <span class="keywordtype">void</span> beginProfile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName);
<a name="l00128"></a>00128 
<a name="l00141"></a>00141             <span class="keywordtype">void</span> endProfile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName);
<a name="l00142"></a>00142 
<a name="l00148"></a>00148             <span class="keywordtype">void</span> setEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00149"></a>00149 
<a name="l00151"></a>00151             <span class="keywordtype">bool</span> getEnabled() <span class="keyword">const</span>;
<a name="l00152"></a>00152 
<a name="l00157"></a>00157             <span class="keywordtype">void</span> enableProfile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName);
<a name="l00158"></a>00158 
<a name="l00163"></a>00163             <span class="keywordtype">void</span> disableProfile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName);
<a name="l00164"></a>00164 
<a name="l00170"></a>00170             <span class="keywordtype">bool</span> watchForMax(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName);
<a name="l00171"></a>00171 
<a name="l00177"></a>00177             <span class="keywordtype">bool</span> watchForMin(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName);
<a name="l00178"></a>00178 
<a name="l00188"></a>00188             <span class="keywordtype">bool</span> watchForLimit(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> limit, <span class="keywordtype">bool</span> greaterThan = <span class="keyword">true</span>);
<a name="l00189"></a>00189 
<a name="l00191"></a>00191             <span class="keywordtype">void</span> logResults();
<a name="l00192"></a>00192 
<a name="l00194"></a>00194             <span class="keywordtype">void</span> reset();
<a name="l00195"></a>00195 
<a name="l00197"></a>00197             <span class="keywordtype">void</span> setUpdateDisplayFrequency(<a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a> freq);
<a name="l00198"></a>00198 
<a name="l00200"></a>00200             <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a> getUpdateDisplayFrequency() <span class="keyword">const</span>;
<a name="l00201"></a>00201 
<a name="l00217"></a>00217             <span class="keyword">static</span> <a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00233"></a>00233             <span class="keyword">static</span> <a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235         <span class="keyword">protected</span>:
<a name="l00236"></a>00236 
<a name="l00238"></a>00238             <span class="keywordtype">void</span> initialize();
<a name="l00239"></a>00239 
<a name="l00241"></a>00241             <span class="keywordtype">void</span> displayResults();
<a name="l00242"></a>00242 
<a name="l00244"></a>00244             <span class="keywordtype">void</span> processFrameStats();
<a name="l00245"></a>00245 
<a name="l00247"></a>00247             <span class="keywordtype">void</span> changeEnableState();
<a name="l00248"></a>00248 
<a name="l00250"></a>00250             <a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>* createContainer();
<a name="l00251"></a>00251 
<a name="l00253"></a>00253             <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* createTextArea(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, 
<a name="l00254"></a>00254                                        <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a> fontSize, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; caption, <span class="keywordtype">bool</span> show = <span class="keyword">true</span>);
<a name="l00255"></a>00255 
<a name="l00257"></a>00257             <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* createPanel(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, 
<a name="l00258"></a>00258                                     <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; materialName, <span class="keywordtype">bool</span> show = <span class="keyword">true</span>);
<a name="l00259"></a>00259 
<a name="l00261"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html">00261</a>             <span class="keyword">struct </span><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html" title="Represents an individual profile call.">ProfileInstance</a> {
<a name="l00262"></a>00262 
<a name="l00264"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#b97c7822bee63c0a8779b6d539bbe0fb">00264</a>                 <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>      name;
<a name="l00265"></a>00265 
<a name="l00267"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#1643d89b6d2e6ae826ed41b473ca971c">00267</a>                 <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>      parent;
<a name="l00268"></a>00268 
<a name="l00270"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#785469fb2684cc7bfd1f58ba9502d422">00270</a>                 <a class="code" href="namespaceOgre.html#4304981347643708ee9a7ba8884e5758">ulong</a>       currTime;
<a name="l00271"></a>00271 
<a name="l00274"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#641ea8c3f3083597216b11e39d929a1e">00274</a>                 <a class="code" href="namespaceOgre.html#4304981347643708ee9a7ba8884e5758">ulong</a>       accum;
<a name="l00275"></a>00275 
<a name="l00277"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#30bc0db31ef4e1ff718d89004e3bff4a">00277</a>                 <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a>        hierarchicalLvl;
<a name="l00278"></a>00278             };
<a name="l00279"></a>00279 
<a name="l00282"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html">00282</a>             <span class="keyword">struct </span><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html" title="Represents the total timing information of a profile since profiles can be called...">ProfileFrame</a> {
<a name="l00283"></a>00283                 
<a name="l00285"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#f444a2a77f7bb3e2387aec94c539a7fb">00285</a>                 <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>  name;
<a name="l00286"></a>00286 
<a name="l00288"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#89cf3553385a4aaadf99061f920249b1">00288</a>                 <a class="code" href="namespaceOgre.html#4304981347643708ee9a7ba8884e5758">ulong</a>   frameTime;
<a name="l00289"></a>00289 
<a name="l00291"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#449b6583375ed3ed8c4a9cd872496cd9">00291</a>                 <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a>    calls;
<a name="l00292"></a>00292 
<a name="l00294"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#f9530dfafd95f21de7c508bb99fe4f84">00294</a>                 <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a>    hierarchicalLvl;
<a name="l00295"></a>00295 
<a name="l00296"></a>00296             };
<a name="l00297"></a>00297             
<a name="l00299"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html">00299</a>             <span class="keyword">struct </span><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html" title="Represents a history of each profile during the duration of the app.">ProfileHistory</a> {
<a name="l00300"></a>00300 
<a name="l00302"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#cf3e9dcca109ad8ed6e480f1253e0873">00302</a>                 <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>  name;
<a name="l00303"></a>00303 
<a name="l00305"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#46033eb24e1a7945d62cd03b53422869">00305</a>                 <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    currentTime; <span class="comment">// %</span>
<a name="l00306"></a>00306 
<a name="l00308"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#604f58a962fbd83d583e178fc7d404f2">00308</a>                 <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    maxTime; <span class="comment">// %</span>
<a name="l00309"></a>00309 
<a name="l00311"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#fd0164fa86995b65375faf527b7cde1c">00311</a>                 <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    minTime; <span class="comment">// %</span>
<a name="l00312"></a>00312 
<a name="l00314"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#b918db2b1abc44372b98ee8ca14d86ad">00314</a>                 <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a>    numCallsThisFrame;
<a name="l00315"></a>00315 
<a name="l00318"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#e56853ba573e6973f6a070eb588d0881">00318</a>                 <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    totalTime; <span class="comment">// %</span>
<a name="l00319"></a>00319 
<a name="l00322"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#da7dfb141aae4c509b518b4f46fae523">00322</a>                 <a class="code" href="namespaceOgre.html#4304981347643708ee9a7ba8884e5758">ulong</a>   totalCalls; <span class="comment">// %</span>
<a name="l00323"></a>00323 
<a name="l00325"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#9ab93f91e00cfdf99f5ef613e9f008d2">00325</a>                 <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a>    hierarchicalLvl;
<a name="l00326"></a>00326 
<a name="l00327"></a>00327             };
<a name="l00328"></a>00328 
<a name="l00329"></a>00329             
<a name="l00330"></a><a class="code" href="classOgre_1_1Profiler.html#abc874a9dc62ed84fb0315fd10f3ca4c">00330</a>             <span class="keyword">typedef</span> std::list&lt;ProfileInstance&gt; ProfileStack;
<a name="l00331"></a><a class="code" href="classOgre_1_1Profiler.html#c7a8f9ffdfa751a0ff76cf8539cc86f5">00331</a>             <span class="keyword">typedef</span> std::list&lt;ProfileFrame&gt; ProfileFrameList;
<a name="l00332"></a><a class="code" href="classOgre_1_1Profiler.html#aea38d758840964314040fca06d6d5b8">00332</a>             <span class="keyword">typedef</span> std::list&lt;ProfileHistory&gt; ProfileHistoryList;
<a name="l00333"></a><a class="code" href="classOgre_1_1Profiler.html#f7b1ce44de5ccb78707fd4817879ea44">00333</a>             <span class="keyword">typedef</span> std::map&lt;String, ProfileHistoryList::iterator&gt; ProfileHistoryMap;
<a name="l00334"></a><a class="code" href="classOgre_1_1Profiler.html#6d6694b6a2854055c1ca40efede9ce62">00334</a>             <span class="keyword">typedef</span> std::map&lt;String, bool&gt; DisabledProfileMap;
<a name="l00335"></a>00335 
<a name="l00336"></a><a class="code" href="classOgre_1_1Profiler.html#39b26412d70c6f1f11114cfcd1d0fce0">00336</a>             <span class="keyword">typedef</span> std::list&lt;OverlayElement*&gt; ProfileBarList;
<a name="l00337"></a>00337 
<a name="l00339"></a><a class="code" href="classOgre_1_1Profiler.html#7342bed28d571f2657b1a3f04ebd59e0">00339</a>             ProfileStack mProfiles;
<a name="l00340"></a>00340 
<a name="l00343"></a><a class="code" href="classOgre_1_1Profiler.html#b6e938d9f36e20068d7f96073112fb77">00343</a>             ProfileFrameList mProfileFrame;
<a name="l00344"></a>00344 
<a name="l00346"></a><a class="code" href="classOgre_1_1Profiler.html#28700bb39bbc70ec4ecac22050d13f2c">00346</a>             ProfileHistoryList mProfileHistory;
<a name="l00347"></a>00347 
<a name="l00349"></a><a class="code" href="classOgre_1_1Profiler.html#ba7e5d0b1b2f41e1c63563d9d49eddba">00349</a>             ProfileHistoryMap mProfileHistoryMap;
<a name="l00350"></a>00350 
<a name="l00352"></a><a class="code" href="classOgre_1_1Profiler.html#3d8be007a0ed8266c06bd27968b7974e">00352</a>             DisabledProfileMap mDisabledProfiles;
<a name="l00353"></a>00353 
<a name="l00355"></a><a class="code" href="classOgre_1_1Profiler.html#b3865827e7b3ac4ad3b9b3e1fdda9d77">00355</a>             ProfileBarList mProfileBars;
<a name="l00356"></a>00356 
<a name="l00358"></a><a class="code" href="classOgre_1_1Profiler.html#8426a136e3fd6574b4b3afeca58fd5d9">00358</a>             <span class="keywordtype">bool</span> mInitialized;
<a name="l00359"></a>00359 
<a name="l00361"></a><a class="code" href="classOgre_1_1Profiler.html#5b03134dbe6bb7a52f2edc1d5b66fe4c">00361</a>             <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a> maxProfiles;
<a name="l00362"></a>00362 
<a name="l00364"></a><a class="code" href="classOgre_1_1Profiler.html#f0b84f8988fb21a9b1edb737687e1d55">00364</a>             <a class="code" href="classOgre_1_1Overlay.html" title="Represents a layer which is rendered on top of the &amp;#39;normal&amp;#39; scene contents...">Overlay</a>* mOverlay;
<a name="l00365"></a>00365 
<a name="l00367"></a><a class="code" href="classOgre_1_1Profiler.html#787571c7aff51fec80a5602a2e868a78">00367</a>             <a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>* mProfileGui;
<a name="l00368"></a>00368 
<a name="l00370"></a><a class="code" href="classOgre_1_1Profiler.html#093f84942dc4ceb8e959588dbcd2cde0">00370</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mBarHeight;
<a name="l00371"></a>00371 
<a name="l00373"></a><a class="code" href="classOgre_1_1Profiler.html#01964e2873acf707b46ce955d4eaa481">00373</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mGuiHeight;
<a name="l00374"></a>00374 
<a name="l00376"></a><a class="code" href="classOgre_1_1Profiler.html#7aa7a6e1aefb5d3fda203ab2bbf2345b">00376</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mGuiWidth;
<a name="l00377"></a>00377 
<a name="l00379"></a><a class="code" href="classOgre_1_1Profiler.html#d777b9d07a5f12464f1fa7c6ed7a21c1">00379</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mBarIndent;
<a name="l00380"></a>00380 
<a name="l00382"></a><a class="code" href="classOgre_1_1Profiler.html#9394507398be0a65c25bc90863eaf6c4">00382</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mGuiBorderWidth;
<a name="l00383"></a>00383 
<a name="l00385"></a><a class="code" href="classOgre_1_1Profiler.html#c914f52e30c8f425a50b1da30c3105a1">00385</a>             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mBarLineWidth;
<a name="l00386"></a>00386 
<a name="l00389"></a><a class="code" href="classOgre_1_1Profiler.html#634f43e704803cbc4c4974d5363d3441">00389</a>             <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a> mUpdateDisplayFrequency;
<a name="l00390"></a>00390 
<a name="l00392"></a><a class="code" href="classOgre_1_1Profiler.html#342bdc46fd887e5c5a45806dfdd6be0b">00392</a>             <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a> mCurrentFrame;
<a name="l00393"></a>00393 
<a name="l00395"></a><a class="code" href="classOgre_1_1Profiler.html#38b67a7679f11d7ececbeedc4f354a1f">00395</a>             <a class="code" href="classOgre_1_1Timer.html" title="Timer class.">Timer</a>* mTimer;
<a name="l00396"></a>00396 
<a name="l00398"></a><a class="code" href="classOgre_1_1Profiler.html#044204c438fc5eec7806b586129cf70e">00398</a>             <a class="code" href="namespaceOgre.html#4304981347643708ee9a7ba8884e5758">ulong</a> mTotalFrameTime;
<a name="l00399"></a>00399 
<a name="l00401"></a><a class="code" href="classOgre_1_1Profiler.html#087887f554607555dbfc34111583bd41">00401</a>             <span class="keywordtype">bool</span> mEnabled;
<a name="l00402"></a>00402 
<a name="l00405"></a><a class="code" href="classOgre_1_1Profiler.html#dca0878a49bfc3a42f5a3329685b60d2">00405</a>             <span class="keywordtype">bool</span> mEnableStateChangePending;
<a name="l00406"></a>00406 
<a name="l00409"></a><a class="code" href="classOgre_1_1Profiler.html#1803e714976005d298d2742fec3e1a09">00409</a>             <span class="keywordtype">bool</span> mNewEnableState;
<a name="l00410"></a>00410 
<a name="l00411"></a>00411     }; <span class="comment">// end class</span>
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 } <span class="comment">// end namespace</span>
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:54 2008
</p>
</body>
</html>
